<Cabbage>
form caption("Pedro's Effect") size(360, 350), colour(51, 68, 84), pluginid("def2")


groupbox bounds(30, 20, 300, 110) text("Pitch") colour(95, 98, 101, 255) fontcolour(255, 255, 255, 255)
rslider bounds(40, 50, 70, 70) range(-12, 12, 7, 1, 1) text("Scale") textcolour(255, 255, 255, 255) channel("pitchscale") valuetextbox(1) fontcolour(255, 255, 255, 255)
rslider bounds(110, 50, 70, 70) range(0, 0.1, 0, 1, 0.001) text("Modul Amp") textcolour(255, 255, 255, 255) channel("pitchmodulA") valuetextbox(1) fontcolour(255, 255, 255, 255)
rslider bounds(180, 50, 70, 70) range(0.1, 30, 0.1, 0.5, 0.1) text("Modul Freq") textcolour(255, 255, 255, 255) channel("pitchmodulF") valuetextbox(1) fontcolour(255, 255, 255, 255)
rslider bounds(250, 50, 70, 70) range(0, 1, 1, 1, 0.001) text("Amount") textcolour(255, 255, 255, 255) channel("pitchamount") valuetextbox(1) fontcolour(255, 255, 255, 255)

groupbox bounds(30, 140, 300, 190) text("Reverb") colour(95, 98, 101, 255) fontcolour(255, 255, 255, 255)

hslider bounds(40, 164, 264, 50) range(0, 1, 0.8, 1, 0.001) text("Feedback") textcolour(255, 255, 255, 255) valuetextbox(1) fontcolour(224, 224, 224, 255) channel("reverbfeed")
hslider bounds(40, 214, 264, 50) range(20, 22000, 1000, 0.5, 1) text("LPF Cutoff") textcolour(255, 255, 255, 255) valuetextbox(1) fontcolour(224, 224, 224, 255) channel("reverbcutoff")
hslider bounds(40, 264, 264, 50) range(0, 1, 0.5, 1, 0.001) text("Dry/Wet") textcolour(255, 255, 255, 255) valuetextbox(1) fontcolour(224, 224, 224, 255) channel("reverbamount")

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-d -n
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1



;************* Instrument 1 manage the effect
instr 1

;Control mappings
kPscale chnget "pitchscale"
kPmodula chnget "pitchmodulA"
kPmodulf chnget "pitchmodulF"
kPamount chnget "pitchamount"

kRfeed chnget "reverbfeed"
kRcutoff chnget "reverbcutoff"
kRamount chnget "reverbamount"

;Take input 
a1 inch 1
;a2 inch 2

;Calculate pitch scale properly
if kPscale < 0 then
	kPscale = 1.5 - 0.5 * 2^(-kPscale/12.0)
else
	kPscale = 2^(kPscale/12.0)
endif

;Pitch modulator
aPitchModul oscil kPmodula, kPmodulf
kPscale += aPitchModul

;Process Pitch Scale (http://www.csounds.com/manual/html/pvscale.html)
ifftsize	=		1024
ioverlap	=		ifftsize / 4
iwinsize	=		ifftsize
iwinshape	=		1; von-Hann window

fftin		pvsanal	a1, ifftsize, ioverlap, iwinsize, iwinshape; fft-analysis of the audio-signal
fftblur	    pvscale	fftin, kPscale, 2, 5; scale
aPitchOut	pvsynth	fftblur; resynthesis


;Considering amount and gain scaling
aOut = a1 + aPitchOut * kPamount
aOut *= (1 - 0.5 * kPamount)

;Calculating reverb
aOutL, aOutR reverbsc aOut, aOut, kRfeed, kRcutoff
aOutL = aOut * (1 - kRamount) + aOutL * kRamount
aOutR = aOut * (1 - kRamount) + aOutR * kRamount

outs aOutL, aOutR
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
;starts instrument 1 and runs it for a week
i1 0 [60*60*24*7] 
</CsScore>
</CsoundSynthesizer>
