<Cabbage>
form caption("Pedro's Synthe") size(400, 400), colour(51, 68, 84), pluginid("def1")
keyboard bounds(10, 300, 381, 95)
rslider bounds(18, 22, 60, 60) range(0.01, 3, 0.1, 1, 0.001) text("Attack") channel("attack")
rslider bounds(88, 22, 60, 60) range(0.01, 3, 0.4, 1, 0.001) text("Release") channel("release")

rslider bounds(158, 22, 60, 60) range(0, 1000, 0, 0.5, 0.001) text("Delay Time") channel("delaytime")
rslider bounds(228, 22, 60, 60) range(0, 0.9, 0, 1, 0.001) text("Delay Feedback") channel("delayfeed")

rslider bounds(18, 88, 60, 60) range(0, 100, 0, 1, 0.001) text("Mod Amp") channel("modulationA")
rslider bounds(88, 88, 60, 60) range(1, 5000, 1, 0.5, 20) text("Mod Freq") channel("modulationF")

rslider bounds(158, 88, 60, 60) range(20, 22000, 22000, 0.5, 1) text("LPF CutOff") channel("cutoff")
rslider bounds(228, 88, 60, 60) range(0, 0.9, 0, 1, 0.001) text("LPF Resonance") channel("res")

signaldisplay bounds(76, 170, 260, 100), colour("lime"), backgroundcolour("black"), displaytype("waveform"), signalvariable("aSig")

groupbox bounds(294, 22, 95, 128) text("Waveforms") colour(31, 78, 118, 255)

checkbox bounds(302, 54, 20, 16) text("Sine") popuptext("Sine")  radiogroup(1) shape("circle") channel("wave1") value(1)
label bounds(326, 54, 44, 16) align("left") text("Sine")

checkbox bounds(302, 84, 20, 16) text("Saw") popuptext("Saw")  radiogroup(1) shape("circle") channel("wave2")
label bounds(326, 84, 44, 16) align("left") text("Saw")

checkbox bounds(302, 114, 20, 16) text("Square") popuptext("Square")  radiogroup(1) shape("circle") channel("wave3")
label bounds(326, 114, 58, 16) align("left") text("Square")


</Cabbage>
<CsoundSynthesizer>
<CsOptions>
;-n --displays -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
-n --displays -+rtmidi=NULL -M0 --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

;Waves
giSaw ftgen 0, 0, 2^16, 10, 1, 0.5, 0.3, 0.25, 0.2, 0.167, 0.14, 0.125, .111
giSquare ftgen 0, 0, 2^16, 10, 1, 0, 0.3, 0, 0.2, 0, 0.14, 0, .111

gaOut init 0

;**************instrument will be triggered by keyboard widget
instr 1

;Controls mapping
iAttack chnget "attack"
iRelease chnget "release"

iShape chnget "waveshape"

kModulA chnget "modulationA"
kModulB chnget "modulationF"

kEnv madsr iAttack, .2, .6, iRelease


;Modulator
aModulator oscil kModulA, kModulB
aModulator = aModulator + 1

;Carrier
if chnget:k("wave1") == 1 then
	aSig oscil  p5 * kEnv, p4 * aModulator
elseif chnget:k("wave2") == 1 then
	aSig oscil  p5 * kEnv, p4 * aModulator, giSaw
elseif chnget:k("wave3") == 1 then
	aSig oscil  p5 * kEnv, p4 * aModulator, giSquare
endif

gaOut += aSig
;outs aOut, aOut
display	aSig, .1, 1
dispfft aSig, .1, 512
endin





;********** Instrument running contantly for feedback
instr 99
;Initializing variable for feedback
aFeed init 0

;Controls mapping
kFeed chnget "delayfeed"
kDel chnget "delaytime"
aDel = interp(kDel) 
aDel tone aDel, 1

kCut chnget "cutoff"
kRes chnget "res"


;Delay w/ feedback
aDel vdelay gaOut + aFeed, aDel, 5000
aFeed = aDel * kFeed

;Panning LFO
aPlfo oscil 1, 1
aPlfo += 1
aPlfo *= 0.5

;Output signals
aOutLeft = (gaOut*0.4) + (aDel * 0.4 * aPlfo)
aOutRight =  (gaOut*0.4) + (aDel * 0.4 * (1 - aPlfo))

; LPF resonant filter
aOutLeft moogladder aOutLeft, interp(kCut), interp(kRes)
aOutRight moogladder aOutRight, interp(kCut), interp(kRes)


;Stereo output
outs aOutLeft, aOutRight

;Zero out global variable to eliminate feedback
gaOut = 0
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
i99 0 z
</CsScore>
</CsoundSynthesizer>
